/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.160 by jmc, Tue Mar 29 11:51:20 2011 UTC revision 1.182 by jmc, Tue Apr 9 20:51:50 2013 UTC
# Line 15  usage() Line 15  usage()
15      echo "  (-mpi)                   use MPI to compile and run on 2 processors"      echo "  (-mpi)                   use MPI to compile and run on 2 processors"
16      echo "  (-MPI)  NUMBER           use MPI to compile and run on max NUMBER procs"      echo "  (-MPI)  NUMBER           use MPI to compile and run on max NUMBER procs"
17      echo "  (-mfile|-mf) STRING      MPI: file with list of possible machines to run on"      echo "  (-mfile|-mf) STRING      MPI: file with list of possible machines to run on"
18      echo "  (-ieee/-noieee)          if possible, use IEEE compiler flags"      echo "  (-fast)                  use optfile default for compiler flags (no '-ieee')"
19      echo "                             (DEF=\"-ieee\")"      echo "                            DEF=off => use IEEE numerics option (if available)"
20        echo "  (-devel)                 use optfile developement flags (if available)"
21      echo "  (-gsl)                   compile with \"-gsl\" flag"      echo "  (-gsl)                   compile with \"-gsl\" flag"
22      echo "  (-use_r4|-ur4)           if allowed, use real*4 type for '_RS' variable"      echo "  (-use_r4|-ur4)           if allowed, use real*4 type for '_RS' variable"
23      echo "  (-optfile|-of) STRING    list of optfiles to use"      echo "  (-optfile|-of) STRING    list of optfiles to use"
# Line 34  usage() Line 35  usage()
35      echo "  (-bash|-b) STRING        preferred location of a \"bash\" or"      echo "  (-bash|-b) STRING        preferred location of a \"bash\" or"
36      echo "                             Bourne-compatible \"sh\" shell"      echo "                             Bourne-compatible \"sh\" shell"
37      echo "                             (DEF=\"\" for \"bash\")"      echo "                             (DEF=\"\" for \"bash\")"
38        echo "  (-tlm)                   perform a Tangent Linear run"
39      echo "  (-adm|-ad)               perform an adjoint run"      echo "  (-adm|-ad)               perform an adjoint run"
40      echo "  (-oad)                   perform an OpenAD adjoint run"      echo "  (-oad)                   perform an OpenAD adjoint run"
41      echo "  (-command|-c) STRING     command to run"      echo "  (-command|-c) STRING     command to run"
# Line 47  usage() Line 49  usage()
49      echo "  (-match) NUMBER          Matching Criteria (number of digits)"      echo "  (-match) NUMBER          Matching Criteria (number of digits)"
50      echo "                             (DEF=\"$MATCH_CRIT\")"      echo "                             (DEF=\"$MATCH_CRIT\")"
51      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"
52        echo "  (-ef) STRING             used as genmake2 \"-extra_flag\" argument"
53      echo "  (-clean)                 *ONLY* run \"make CLEAN\" & clean run-dir"      echo "  (-clean)                 *ONLY* run \"make CLEAN\" & clean run-dir"
54      echo "  (-norun|-nr)             skip the \"runmodel\" stage (stop after make)"      echo "  (-norun|-nr)             skip the \"runmodel\" stage (stop after make)"
55        echo "  (-obj)                   only produces objects (=norun & no executable)"
56      echo "  (-runonly|-ro)           *ONLY* run stage (=\"-quick\" without make)"      echo "  (-runonly|-ro)           *ONLY* run stage (=\"-quick\" without make)"
57      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""
58      echo "  (-nogenmake|-ng)         skip the genmake stage"      echo "  (-nogenmake|-ng)         skip the genmake stage"
# Line 114  testoutput_var() Line 118  testoutput_var()
118      # testoutput_var dir s1 label subdir reference_output      # testoutput_var dir s1 label subdir reference_output
119      #      #
120      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE
121      #     with same output from reference file $dir/results/$reference_output      #     with same output from reference file $dir/$reference_output
122      #  using search strings s1 and text label      #  using search strings s1 and text label
123    
124      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
# Line 127  testoutput_var() Line 131  testoutput_var()
131              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
132                  echo Not enough lines of output when searching for "$2" 1>&2                  echo Not enough lines of output when searching for "$2" 1>&2
133              fi              fi
134              return 99              rm -f tmp1.txt ; return 99
135          fi          fi
136      else      else
137          echo testoutput_var: $OUTPUTFILE from model run was not readable 1>&2          echo testoutput_var: $OUTPUTFILE from model run was not readable 1>&2
138          return 99          return 99
139      fi      fi
140      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
141          echo testoutput_var: grep "$2" $1/results/$5 1>&2          echo testoutput_var: grep "$2" $1/$5 1>&2
142      fi      fi
143      grep "$2" $1/results/$5 | sed 's/.*=//' | cat -n > tmp2.txt      grep "$2" $1/$5 | sed 's/.*=//' | cat -n > tmp2.txt
144      lncntB=`wc -l tmp2.txt | awk '{print $1}' `      lncntB=`wc -l tmp2.txt | awk '{print $1}' `
145      if [ $lncntB -lt 2 ]; then      if [ $lncntB -lt 2 ]; then
146          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
147              echo Not enough lines of output when searching for "$2" 1>&2              echo Not enough lines of output when searching for "$2" 1>&2
148          fi          fi
149          return 99          rm -f tmp1.txt tmp2.txt ; return 99
150      fi      fi
151      if [ $lncntA -ne $lncntB ]; then      if [ $lncntA -ne $lncntB ]; then
152          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
153              echo Not same Nb of lines when searching for "$2" ":" $lncntA $lncntB 1>&2              echo Not same Nb of lines when searching for "$2" ":" $lncntA $lncntB 1>&2
154          fi          fi
155          return 99          rm -f tmp1.txt tmp2.txt ; return 99
156      fi      fi
157      has_nan=`cat tmp1.txt | grep -i nan | wc -l`      has_nan=`cat tmp1.txt | grep -i nan | wc -l`
158      if [ $has_nan -gt 0  ] ; then      if [ $has_nan -gt 0  ] ; then
159          echo testoutput_var: $OUTPUTFILE contains $has_nan NaN values  1>&2          echo testoutput_var: $OUTPUTFILE contains $has_nan NaN values  1>&2
160          return 99          rm -f tmp1.txt tmp2.txt ; return 99
161      fi      fi
162      has_inf=`cat tmp1.txt | grep -i inf | wc -l`      has_inf=`cat tmp1.txt | grep -i inf | wc -l`
163      if [ $has_inf -gt 0  ] ; then      if [ $has_inf -gt 0  ] ; then
164          echo testoutput_var: $OUTPUTFILE contains $has_inf Inf values  1>&2          echo testoutput_var: $OUTPUTFILE contains $has_inf Inf values  1>&2
165          return 99          rm -f tmp1.txt tmp2.txt ; return 99
166      fi      fi
167      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
168          echo testoutput_var: join tmp1.txt tmp2.txt 1>&2          echo testoutput_var: join tmp1.txt tmp2.txt 1>&2
# Line 195  testoutput_run() Line 199  testoutput_run()
199      #      #
200      #  test output from 1 run in "directory"      #  test output from 1 run in "directory"
201  # --> same processing for adjoint & forward test  # --> same processing for adjoint & forward test
202          # default list of output variables to be checked:          # default list of output variables to be checked:
203          #  1rst : main variable used to decide if it pass or FAIL          #  1rst : main variable used to decide if it pass or FAIL
204          #  others : number of matching digits to be printed in summary.txt          #  others : number of matching digits to be printed in summary.txt
205          listChk=$DEF_CHECK_LIST          listChk=$DEF_CHECK_LIST
206          #  load experiment-specific list from file "tr_checklist" (if it exist)          #  load experiment-specific list from file "tr_checklist" (if it exist)
207          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi
208          sVar=`echo $listChk | awk '{print $1}'`          sVar=`echo $listChk | awk '{print $1}'`
209          # remove 1rst var and expand the list: + => min max mean s.d          # remove 1rst var and expand the list: + => min max mean s.d
210          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \
211                                 | sed 's/+//g' | sed "s/^$sVar//"`                                 | sed 's/+//g' | sed "s/^$sVar//"`
212          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi
213          # check for ptracer output in reference_output file :          # set ref.outp file-name and, if compressed, uncompress it into subdir
214          outpref=$1/results/$3          refoutp=results/$3
215          ptr_mon="trcstat_ptracerXX_min trcstat_ptracerXX_max"          if test ! -r $1/results/$3 ; then
216          ptr_mon="$ptr_mon trcstat_ptracerXX_mean trcstat_ptracerXX_sd"            if test -r $1/results/${3}.gz ; then
217          for ii in $PTRACERS_NUM ; do              tmpNam1=$3
218                tmpNam2=`echo $tmpNam1 | sed 's/\..*\././'`
219                if test "x$tmpNam1" = "x$tmpNam2" ; then
220                    tmpNam1=`echo $tmpNam2 | sed 's/\./.std./'`
221                fi
222                refoutp=$2/$tmpNam1
223                if [ $debug -gt 0 ]; then
224                    echo "testoutput_run: gunzip 'results/$3.gz' into '$refoutp'" 1>&2
225                fi
226                gzip -cd $1/results/${3}.gz > $1/$refoutp
227              else
228                echo "missing reference output file '$3' (.gz) in '$1/results/'"
229              fi
230            fi
231            # check for ptracer output in reference_output file :
232            if test $KIND = 0 ; then
233              ptr_mon="trcstat_ptracerXX_min trcstat_ptracerXX_max"
234              ptr_mon="$ptr_mon trcstat_ptracerXX_mean trcstat_ptracerXX_sd"
235              for ii in $PTRACERS_NUM ; do
236              ptrfound=0              ptrfound=0
237              for jj in $ptr_mon ; do              for jj in $ptr_mon ; do
238                  name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`                  name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`
239                  tst=`grep $name $outpref | wc -l | awk '{print $1}'`                  tst=`grep $name $1/$refoutp | wc -l | awk '{print $1}'`
240                  if test ! "x$tst" = x0 ; then ptrfound=1 ; fi                  if test ! "x$tst" = x0 ; then ptrfound=1 ; fi
241              done              done
242              if test $ptrfound = '1' ; then              if test $ptrfound = '1' ; then
243                  eval "HAVE_PTR0"$ii"=t"                  eval "HAVE_PTR0"$ii"=t"
244              else              else
245                  eval "HAVE_PTR0"$ii"=f"                  eval "HAVE_PTR0"$ii"=f"
               if test "x$ADM" = x -a "x$OADM" = x; then  
246                # remove this ptr from the list of output variable to check                # remove this ptr from the list of output variable to check
247                # echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2                # echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2
248                  listVar=`echo "$listVar" | sed "s/ pt$ii..//g"`                  listVar=`echo "$listVar" | sed "s/ pt$ii..//g"`
               fi  
249              fi              fi
250          #   eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"' 1>&2            # eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"' 1>&2
251          done            done
252          tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){if($i==$1)t+=1}; print t }'`          fi
253          if test $tst != 1 ; then          tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){if($i==$1)t+=1}; print t }'`
254            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2          if test $tst != 1 ; then
255                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2
256            echo "==> WARNING: in checked list:" $listVar 1>&2                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi
257          #- put it back once:            echo "==> WARNING: in checked list:" $listVar 1>&2
258            listVar=" $sVar "`echo "$listVar " | sed "s/ $sVar / /g"`          #- put it back once:
259          fi            listVar=" $sVar "`echo "$listVar " | sed "s/ $sVar / /g"`
260            fi
261          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(M)='$listVar'" 1>&2 ; fi          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(M)='$listVar'" 1>&2 ; fi
262          echo "listVar='$listVar'" >> $locDIR"/summary.txt"          echo "listVar='$listVar'" >> $locDIR"/summary.txt"
263          #---          #---
264          allargs=""          allargs=""
265          for xx in $listVar          for xx in $listVar
266          do          do
267            case $xx in            case $xx in
268             'PS')  if [ $debug -gt 0 ]             'PS')  if [ $debug -gt 0 ]
269                    then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi                    then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi
270                    testoutput_var $1 "cg2d_init_res" "Press. Solver (cg2d)" $2 $3; yy=$?                    testoutput_var $1 "cg2d_init_res" "Press. Solver (cg2d)" $2 $refoutp ; yy=$?
271                    if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;                    if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;
272            'Cost') testoutput_var $1 "ADM  precision_derivative_cost" "ADM Cost" $2 $3; yy=$? ;;            'Cost') testoutput_var $1 "ADM  ref_cost_function" "ADM CostFct" $2 $refoutp ; yy=$? ;;
273            'Grad') testoutput_var $1 "ADM  precision_derivative_grad" "ADM Grad" $2 $3; yy=$? ;;           'AdGrd') testoutput_var $1 "ADM  adjoint_gradient"  "ADM Ad Grad" $2 $refoutp ; yy=$? ;;
274             'Tmn') testoutput_var $1 "dynstat_theta_min"  "Theta minimum"  $2 $3; yy=$? ;;           'FDGrd') testoutput_var $1 "ADM  finite-diff_grad"  "ADM FD Grad" $2 $refoutp ; yy=$? ;;
275             'Tmx') testoutput_var $1 "dynstat_theta_max"  "Theta maximum"  $2 $3; yy=$? ;;          'tlmCst') testoutput_var $1 "TLM  ref_cost_function" "TLM CostFct" $2 $refoutp ; yy=$? ;;
276             'Tav') testoutput_var $1 "dynstat_theta_mean" "Theta mean"     $2 $3; yy=$? ;;          'tlmGrd') testoutput_var $1 "TLM  tangent-lin_grad"  "TLM TL Grad" $2 $refoutp ; yy=$? ;;
277             'Tsd') testoutput_var $1 "dynstat_theta_sd"   "Theta Std.Dev"  $2 $3; yy=$? ;;          'fwdGrd') testoutput_var $1 "TLM  finite-diff_grad"  "TLM FD Grad" $2 $refoutp ; yy=$? ;;
278             'Smn') testoutput_var $1 "dynstat_salt_min"  "Salt minimum"    $2 $3; yy=$? ;;             'Tmn') testoutput_var $1 "dynstat_theta_min"  "Theta minimum"  $2 $refoutp ; yy=$? ;;
279             'Smx') testoutput_var $1 "dynstat_salt_max"  "Salt maximum"    $2 $3; yy=$? ;;             'Tmx') testoutput_var $1 "dynstat_theta_max"  "Theta maximum"  $2 $refoutp ; yy=$? ;;
280             'Sav') testoutput_var $1 "dynstat_salt_mean" "Salt mean"       $2 $3; yy=$? ;;             'Tav') testoutput_var $1 "dynstat_theta_mean" "Theta mean"     $2 $refoutp ; yy=$? ;;
281             'Ssd') testoutput_var $1 "dynstat_salt_sd"   "Salt Std.Dev"    $2 $3; yy=$? ;;             'Tsd') testoutput_var $1 "dynstat_theta_sd"   "Theta Std.Dev"  $2 $refoutp ; yy=$? ;;
282             'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $3; yy=$? ;;             'Smn') testoutput_var $1 "dynstat_salt_min"  "Salt minimum"    $2 $refoutp ; yy=$? ;;
283             'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $3; yy=$? ;;             'Smx') testoutput_var $1 "dynstat_salt_max"  "Salt maximum"    $2 $refoutp ; yy=$? ;;
284             'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $3; yy=$? ;;             'Sav') testoutput_var $1 "dynstat_salt_mean" "Salt mean"       $2 $refoutp ; yy=$? ;;
285             'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U Std.Dev"       $2 $3; yy=$? ;;             'Ssd') testoutput_var $1 "dynstat_salt_sd"   "Salt Std.Dev"    $2 $refoutp ; yy=$? ;;
286             'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $3; yy=$? ;;             'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $refoutp ; yy=$? ;;
287             'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $3; yy=$? ;;             'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $refoutp ; yy=$? ;;
288             'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $3; yy=$? ;;             'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $refoutp ; yy=$? ;;
289             'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V Std.Dev"       $2 $3; yy=$? ;;             'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U Std.Dev"       $2 $refoutp ; yy=$? ;;
290               'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $refoutp ; yy=$? ;;
291               'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $refoutp ; yy=$? ;;
292               'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $refoutp ; yy=$? ;;
293               'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V Std.Dev"       $2 $refoutp ; yy=$? ;;
294          'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
295             testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $refoutp ; yy=$? ;;
296          'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
297             testoutput_var $1 "trcstat_ptracer0"$ii"_max"  "p0"$ii"_max"   $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_max"  "p0"$ii"_max"   $2 $refoutp ; yy=$? ;;
298          'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
299             testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $refoutp ; yy=$? ;;
300          'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
301             testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $refoutp ; yy=$? ;;
302           'Qntmn') testoutput_var $1 "forcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;           'Qntmn') testoutput_var $1 "forcing_qnet_min" "Qnet minimum"  $2 $refoutp ; yy=$? ;;
303           'Qntmx') testoutput_var $1 "forcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;           'Qntmx') testoutput_var $1 "forcing_qnet_max" "Qnet maximum"  $2 $refoutp ; yy=$? ;;
304           'Qntav') testoutput_var $1 "forcing_qnet_mean" "Qnet mean"       $2 $3; yy=$? ;;           'Qntav') testoutput_var $1 "forcing_qnet_mean" "Qnet mean"       $2 $refoutp ; yy=$? ;;
305           'Qntsd') testoutput_var $1 "forcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;           'Qntsd') testoutput_var $1 "forcing_qnet_sd"  "Qnet Std.Dev"  $2 $refoutp ; yy=$? ;;
306           'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;           'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $refoutp ; yy=$? ;;
307           'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;           'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $refoutp ; yy=$? ;;
308           'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;           'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $refoutp ; yy=$? ;;
309           'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $3; yy=$? ;;           'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $refoutp ; yy=$? ;;
310           'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $3; yy=$? ;;           'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $refoutp ; yy=$? ;;
311           'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Heff max"   $2 $3; yy=$? ;;           'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Heff max"   $2 $refoutp ; yy=$? ;;
312           'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Heff mean"  $2 $3; yy=$? ;;           'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Heff mean"  $2 $refoutp ; yy=$? ;;
313           'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Heff StDv"  $2 $3; yy=$? ;;           'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Heff StDv"  $2 $refoutp ; yy=$? ;;
314          'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $3; yy=$? ;;           'uSImn') testoutput_var $1 "seaice_uice_min"   "SIce Uice min"   $2 $refoutp ; yy=$? ;;
315          'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $3; yy=$? ;;           'uSImx') testoutput_var $1 "seaice_uice_max"   "SIce Uice max"   $2 $refoutp ; yy=$? ;;
316          'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $3; yy=$? ;;           'uSIav') testoutput_var $1 "seaice_uice_mean"  "SIce Uice mean"  $2 $refoutp ; yy=$? ;;
317          'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Global"    $2 $3; yy=$? ;;           'uSIsd') testoutput_var $1 "seaice_uice_sd"    "SIce Uice StDv"  $2 $refoutp ; yy=$? ;;
318          'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South"     $2 $3; yy=$? ;;           'vSImn') testoutput_var $1 "seaice_vice_min"   "SIce Vice min"   $2 $refoutp ; yy=$? ;;
319          'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North"     $2 $3; yy=$? ;;           'vSImx') testoutput_var $1 "seaice_vice_max"   "SIce Vice max"   $2 $refoutp ; yy=$? ;;
320                *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;           'vSIav') testoutput_var $1 "seaice_vice_mean"  "SIce Vice mean"  $2 $refoutp ; yy=$? ;;
321            esac           'vSIsd') testoutput_var $1 "seaice_vice_sd"    "SIce Vice StDv"  $2 $refoutp ; yy=$? ;;
322            if test $xx = $sVar          'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $refoutp ; yy=$? ;;
323            then allargs="$allargs > $yy <"          'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $refoutp ; yy=$? ;;
324            else allargs="$allargs $yy"          'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $refoutp ; yy=$? ;;
325            fi          'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Glob-ave"  $2 $refoutp ; yy=$? ;;
326          done          'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South-av"  $2 $refoutp ; yy=$? ;;
327            'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North-av"  $2 $refoutp ; yy=$? ;;
328            'HthMxS') testoutput_var $1 "thSI_IceH_max_S" "thSIc H South-max" $2 $refoutp ; yy=$? ;;
329            'HthMxN') testoutput_var $1 "thSI_IceH_max_N" "thSIc H North-max" $2 $refoutp ; yy=$? ;;
330                  *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;
331              esac
332              if test $xx = $sVar
333              then allargs="$allargs > $yy <"
334              else allargs="$allargs $yy"
335              fi
336            done
337    
338          nbVar=`echo $listVar | awk '{print NF}'`          nbVar=`echo $listVar | awk '{print NF}'`
339          if [ $nbVar -lt $LEN_CHECK_LIST ] ; then          if [ $nbVar -lt $LEN_CHECK_LIST ] ; then
340          #-- fill line (up to standard length) with dot:          #-- fill line (up to standard length) with dot:
341            adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`            adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`
342            echo $allargs $adNul            echo $allargs $adNul
343          else          else
344            echo $allargs            echo $allargs
345          fi          fi
346  # <-- same processing for adjoint & forward test  # <-- same processing for adjoint & forward test
# Line 328  genmakemodel() Line 363  genmakemodel()
363              if test "x$MKDEPEND" != x ; then              if test "x$MKDEPEND" != x ; then
364                  command="$command -makedepend=$MKDEPEND"                  command="$command -makedepend=$MKDEPEND"
365              fi              fi
366              if test "x$ADM" = xt ; then              if test $KIND = 1 -o $KIND = 2 ; then
367                  command="$command --mods=../code_ad"                  command="$command --mods=../code_ad"
368              elif test "x$OADM" = xt ; then              elif test $KIND = 4 ; then
369                  command="$command -adof ../../../tools/adjoint_options/adjoint_oad -mods '../code_oad ../../OpenAD/code_oad_all'"                  command="$command -adof ../../../tools/adjoint_options/adjoint_oad -mods '../code_oad ../../OpenAD/code_oad_all'"
370              else              else
371                  command="$command -mods=../code"                  command="$command -mods=../code"
# Line 338  genmakemodel() Line 373  genmakemodel()
373              if test "x$OPTFILE" != xNONE ; then              if test "x$OPTFILE" != xNONE ; then
374                  command="$command -optfile=$OPTFILE"                  command="$command -optfile=$OPTFILE"
375              fi              fi
376              if test "x$IEEE" != x ; then              if test $OptLev = 1 ; then
377                  command="$command -ieee"                  command="$command -ieee"
378              fi              fi
379                if test $OptLev = 0 ; then
380                    command="$command -devel"
381                fi
382              if test "x$GSL" = xt ; then              if test "x$GSL" = xt ; then
383                  command="$command -gsl"                  command="$command -gsl"
384              fi              fi
# Line 354  genmakemodel() Line 392  genmakemodel()
392              if test "x$USE_R4" = xt ; then              if test "x$USE_R4" = xt ; then
393                  command="$command -use_r4"                  command="$command -use_r4"
394              fi              fi
395                if test "x$EXTRFLG" != x ; then
396                    command="$command -extra_flag $EXTRFLG"
397                fi
398              if test "x$TS" = xt ; then              if test "x$TS" = xt ; then
399                  command="$command -ts"                  command="$command -ts"
400              fi              fi
# Line 424  run_clean() Line 465  run_clean()
465              find . -name "*.data" -exec rm {} \;              find . -name "*.data" -exec rm {} \;
466              find . -name "fort.*" -exec rm {} \;              find . -name "fort.*" -exec rm {} \;
467              find . -type l -exec rm {} \;              find . -type l -exec rm {} \;
468              #- should remove executable only if sym-link (and above does it)              #- should remove executable only if sym-link (alredy done above)
469              #rm -f $EXECUTABLE              rm -f $RUNLOG *.txt STD* w2_tile_topology.????.log *diagnostics.log datetime
             rm -f $RUNLOG *.txt STD* *diagnostics.log datetime  
470              rm -rf mnc_test_*              rm -rf mnc_test_*
471              rm -f *_MIT_CE_000.opt0000 costfunction*0000              rm -f *_MIT_CE_000.opt0000 costfunction*0000
472              echo successful              echo successful
473              exit 0              exit 0
474          )          )
# Line 475  makemodel() Line 515  makemodel()
515          cd $1;          cd $1;
516          if test -r Makefile ; then          if test -r Makefile ; then
517              printf 'make ... '              printf 'make ... '
518              if test "x$ADM" = xt ; then              if test "x$REPLMAKE" = x ; then
519                  $MAKE adall >> make.tr_log 2>&1                  $MAKE $TARG >> make.tr_log 2>&1
520              elif test "x$OADM" = xt ; then              else
521                  $MAKE adAll >> make.tr_log 2>&1                  $REPLMAKE $TARG >> make.tr_log 2>&1
             else  
                 if test "x$JOBS" = x ; then  
                     $MAKE >> make.tr_log 2>&1  
                 else  
                     $MAKE -j $JOBS >> make.tr_log 2>&1  
                 fi  
522              fi              fi
523              RETVAL=$?              RETVAL=$?
524              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
525                  tail make.tr_log                  tail make.tr_log
526                  echo failed                  echo failed
527                  cp make.tr_log genmake.log genmake.tr_log $CDIR                  cp genmake.log genmake.tr_log $CDIR
528                    tail -$NBLINES_MKLOG make.tr_log > $CDIR"/make.tr_log_tail"
529                  rm -f $EXECUTABLE                  rm -f $EXECUTABLE
530                  mk_fail=1                  mk_fail=1
531              else              else
# Line 501  makemodel() Line 536  makemodel()
536              mk_fail=2              mk_fail=2
537          fi          fi
538      fi      fi
539      if test "x$ADM" = xt -a -f taf_ad.log ; then      if test $KIND = 1 -a -f taf_ftl.log ; then
540                head -1 taf_ftl.log >> $CDIR"/summary.txt"
541        fi
542        if test $KIND = 2 -a -f taf_ad.log ; then
543              head -1 taf_ad.log >> $CDIR"/summary.txt"              head -1 taf_ad.log >> $CDIR"/summary.txt"
544              nerr=`grep -c 'TAF *.* ERROR ' taf_ad.log`              nerr=`grep -c 'TAF *.* ERROR ' taf_ad.log`
545              nwar=`grep -c 'TAF RECOMPUTATION *.* WARNING ' taf_ad.log`              nwar=`grep -c 'TAF RECOMPUTATION *.* WARNING ' taf_ad.log`
# Line 514  makemodel() Line 552  makemodel()
552    
553  mk_mpi_size()  mk_mpi_size()
554  {  {
555      # mk_mpi_size input_file output_file proc_Nb      # mk_mpi_size input_file output_file proc_Nb threads_Nb_X threads_Nb_Y
556      #      #
557      # make new SIZE.h (=output_file) from SIZE.h_mpi (=input_file)      #  make new SIZE.h (=output_file) from SIZE.h_mpi (=input_file)
558      #     for an MPI build with no more than proc_Nb processors ;      #     for an MPI build with no more than proc_Nb processors ;
559      # return the effective number of processors.      #  ensure that enough tiles per proc (nSx,nSy) remain for the given
560        #     number of threads (nTx,nTy) ;
561        #  return the effective number of processors.
562    
563      inp=$1      inp=$1
564      out=$2      out=$2
565      np=$3      np=$3
566        tx=$4
567        ty=$5
568      tmp=TTT.$$      tmp=TTT.$$
569    
570        # dirX : select with direction to favor in MPI process repartition
571        #   dirX=1 : prefer to put more proc in X direction
572        #   dirX=0 : prefer to put more proc in Y direction
573        dirX=0
574    
575      px=`grep "^     & *nPx *=" $inp | sed "s/^     & *nPx *= *//" | sed 's/, *$//'`      px=`grep "^     & *nPx *=" $inp | sed "s/^     & *nPx *= *//" | sed 's/, *$//'`
576      py=`grep "^     & *nPy *=" $inp | sed "s/^     & *nPy *= *//" | sed 's/, *$//'`      py=`grep "^     & *nPy *=" $inp | sed "s/^     & *nPy *= *//" | sed 's/, *$//'`
577      sx=`grep "^     & *nSx *=" $inp | sed "s/^     & *nSx *= *//" | sed 's/, *$//'`      sx=`grep "^     & *nSx *=" $inp | sed "s/^     & *nSx *= *//" | sed 's/, *$//'`
578      sy=`grep "^     & *nSy *=" $inp | sed "s/^     & *nSy *= *//" | sed 's/, *$//'`      sy=`grep "^     & *nSy *=" $inp | sed "s/^     & *nSy *= *//" | sed 's/, *$//'`
579    
580        #- for each direction, assume # of threads is a multiple of total number of tiles
581        nx=$px
582        if [ `expr $sx % $tx` -ne 0 -a `expr $sx \* $px % $tx` -eq 0 ] ; then
583            nx=`expr $sx \* $px / $tx`
584            if [ $verbose -gt 1 ]; then
585                echo " change px from $px to $nx to accommodate $tx threads"
586            fi
587        fi
588        ny=$py
589        if [ `expr $sy % $ty` -ne 0 -a `expr $sy \* $py % $ty` -eq 0 ] ; then
590            ny=`expr $sy \* $py / $ty`
591            if [ $verbose -gt 1 ]; then
592                echo " change py from $py to $ny to accommodate $ty threads"
593            fi
594        fi
595      #- find the largest divisor of input_file proc Nb, but not larger than $np      #- find the largest divisor of input_file proc Nb, but not larger than $np
596      pp=0      pp=0
597      i=1      i=1
598      while [ $i -le $px ] ; do      while [ $i -le $nx ] ; do
599        if [ `expr $px % $i` -eq 0 ] ; then        if [ `expr $nx % $i` -eq 0 ] ; then
600          j=1          j=1
601          while [ $j -le $py ] ; do          while [ $j -le $ny ] ; do
602            if [ `expr $py % $j` -eq 0 ] ; then            if [ `expr $ny % $j` -eq 0 ] ; then
603              ij=`expr $i \* $j`              ij=`expr $i \* $j`
604              if [ $ij -gt $pp ] ; then              if [ $ij -gt $pp ] ; then
605                    flag=1
606                elif [ $ij -eq $pp ] ; then
607                    flag=$dirX
608                else
609                    flag=0
610                fi
611                if test $flag = 1 ; then
612                if [ $ij -le $np ] ; then                if [ $ij -le $np ] ; then
613                  ix=$i ; jy=$j ; pp=$ij                  ix=$i ; jy=$j ; pp=$ij
614                  #echo "  ix,jy= $ix,$jy"                  #echo "  ix,jy= $ix,$jy"
# Line 623  linkdata() Line 692  linkdata()
692          (          (
693              cd $1 ; shift              cd $1 ; shift
694              echo 'linkdata from dirs:' $*              echo 'linkdata from dirs:' $*
695              inpMPI=`(cd ../$1 ; find . -name "*.mpi" -print | sed 's:^\./::')`              inpMPI=`(cd ../$1 ; find . -name "*.mpi" -print | sed 's:^\./::')`
696              for xx in $inpMPI ; do              for xx in $inpMPI ; do
697                if test -r "../"$1"/"$xx ; then                if test -r "../"$1"/"$xx ; then
698                  # found 1 _mpi sfx file in 1rst input dir and it is readable                  # found 1 _mpi sfx file in 1rst input dir and it is readable
699                  yy=`echo $xx | sed 's:\.mpi$::'`                  yy=`echo $xx | sed 's:\.mpi$::'`
700                  if test "x$MPI" = "x0" ; then                  if test "x$MPI" = "x0" ; then
701                      # not mpi test: remove symbolic link                      # not mpi test: remove symbolic link
# Line 658  linkdata() Line 727  linkdata()
727              prevDir='NONE'              prevDir='NONE'
728              for ldir in $* ; do              for ldir in $* ; do
729                  if test -d "../"$ldir -a $ldir != $prevDir ; then                  if test -d "../"$ldir -a $ldir != $prevDir ; then
730                      printf " ldir=${ldir}:" 1>&2                      printf " ldir=${ldir}:" 1>&2
731                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`
732                      for i in $files ; do                      for i in $files ; do
733                          if test ! -d "../"$ldir/$i ; then                          if test ! -d "../"$ldir/$i ; then
# Line 706  runmodel() Line 775  runmodel()
775            else rm -f $EXECUTABLE            else rm -f $EXECUTABLE
776            fi            fi
777          fi          fi
778          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
779              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp
780              ln -sf "../"$builddir"/"$EXECUTABLE .              ln -sf "../"$builddir"/"$EXECUTABLE .
781          fi          fi
782          if test ! -x $EXECUTABLE ; then          if test ! -x $EXECUTABLE ; then
783              rm -f $RUNLOG ; touch $RUNLOG              rm -f $RUNLOG ; touch $RUNLOG
784              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
785              echo " no executable:" $EXECUTABLE >> $RUNLOG              echo " no executable:" $EXECUTABLE >> $RUNLOG
786              RETVAL=8              RETVAL=8
787              ENDVAL=-1              ENDVAL=-1
788          else          else
789            if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then            if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then
790              # output do not exist or is older than executable:              # output do not exist or is older than executable:
791              rm -f $RUNLOG ; touch $RUNLOG              rm -f $OUTPUTFILE $RUNLOG ; touch $RUNLOG
792              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
793              ( eval $COMMAND ) >> $RUNLOG 2>&1              ( eval $COMMAND ) >> $RUNLOG 2>&1
794              RETVAL=$?              RETVAL=$?
# Line 734  runmodel() Line 803  runmodel()
803              ENDVAL=`tail $OUTPUTFILE | grep -c 'PROGRAM MAIN: Execution ended Normally'`              ENDVAL=`tail $OUTPUTFILE | grep -c 'PROGRAM MAIN: Execution ended Normally'`
804              touch $RUNLOG              touch $RUNLOG
805              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
806              echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1              echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
807            fi            fi
808          fi          fi
809          rm -f run.log_tmp          rm -f run.log_tmp
810          #- in all cases where OutputFile exists, report SIZE (and AD time)          #- in all cases where OutputFile exists, report SIZE and time
811          if test -f $OUTPUTFILE ; then          if test -f $OUTPUTFILE ; then
812            grep '(PID\.TID 0000\.0001)      n.. =' $OUTPUTFILE \            grep '(PID\.TID 0000\.0001)      n.. =' $OUTPUTFILE \
813                  | sed 's/(PID.TID 0000.0001)     //' >> $CDIR"/summary.txt"                  | sed 's/(PID.TID 0000.0001)   //' >> $CDIR"/summary.txt"
814            if test "x$ADM" = xt ; then            grep -A3 'Seconds in section "ALL' $OUTPUTFILE \
815              grep -A3 'Seconds in section "ALL' $OUTPUTFILE >> $CDIR"/summary.txt"                  | sed 's/(PID.TID 0000.0001)   //' >> $CDIR"/summary.txt"
           fi  
816          fi          fi
817          if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi          if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
818          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then
# Line 854  scandirs() Line 922  scandirs()
922  {  {
923      if [ $# -eq 1 ]; then      if [ $# -eq 1 ]; then
924          for arg in * ; do          for arg in * ; do
925              test -f $arg/$1 && echo $arg             #test -f $arg/$1 && echo $arg
926                test -f $arg/$1 -o -f $arg/$1.gz && echo $arg
927          done          done
928      else      else
929          echo $*          echo $*
# Line 864  scandirs() Line 933  scandirs()
933    
934  check_eedata()  check_eedata()
935  {  {
936      # check_eedata size.h eedata      # check_eedata eedata size.h
937      if [ $# -eq 2 ] ; then      if [ $# -eq 2 ] ; then
938        if test -f $1 -a -f $2 ; then       if test -f $1 -a -f $2 ; then
939        sx=`grep "^     & *nSx *=" $1 | sed "s/^     & *nSx *=//" | sed 's/, *$//'`        nx=`grep "^ *nTx *=" $1 | tail -1 | sed 's/^ *nTx *= *//' | sed "s/, *$//"`
940        nx=`grep "^ *nTx *=" $2 | tail -1 | sed 's/^ *nTx *= *//' | sed "s/, *$//"`        sx=`grep "^     & *nSx *=" $2 | sed "s/^     & *nSx *=//" | sed 's/, *$//'`
941        if test "x$nx" = x ; then        if test "x$nx" = x ; then
942          rx=10          rx=10
943        else        else
944          rx=`expr $sx % $nx`          rx=`expr $sx % $nx`
945        fi        fi
946        sy=`grep "^     & *nSy *=" $1 | sed "s/^     & *nSy *=//" | sed 's/, *$//'`        ny=`grep "^ *nTy *=" $1 | tail -1 | sed 's/^ *nTy *= *//' | sed "s/, *$//"`
947        ny=`grep "^ *nTy *=" $2 | tail -1 | sed 's/^ *nTy *= *//' | sed "s/, *$//"`        sy=`grep "^     & *nSy *=" $2 | sed "s/^     & *nSy *=//" | sed 's/, *$//'`
948        if test "x$ny" = x ; then        if test "x$ny" = x ; then
949          ry=20          ry=20
950        else        else
951          ry=`expr $sy % $ny`          ry=`expr $sy % $ny`
952        fi        fi
953        echo `expr $rx + $ry`        echo `expr $rx + $ry`
954      else       else
955        echo '-1'        echo '-1'
956        fi       fi
957        elif [ $# -eq 1 ] ; then
958         if test -f $1 ; then
959          nx=`grep "^ *nTx *=" $1 | tail -1 | sed 's/^ *nTx *= *//' | sed "s/, *$//"`
960          if test "x$nx" = x ; then nx=1 ; fi
961          ny=`grep "^ *nTy *=" $1 | tail -1 | sed 's/^ *nTy *= *//' | sed "s/, *$//"`
962          if test "x$ny" = x ; then ny=1 ; fi
963         #echo $nx $ny
964          echo $nx
965         else
966          echo '-1'
967         fi
968      else      else
969        echo '-2'        echo '-2'
970      fi      fi
# Line 897  check_eedata() Line 977  check_eedata()
977  #  Default properties  #  Default properties
978  debug=0  debug=0
979  verbose=1  verbose=1
980    NBLINES_MKLOG=16000
981    
982  IEEE=true  OptLev=1
 if test "x$MITGCM_IEEE" != x ; then  
     IEEE=$MITGCM_IEEE  
 fi  
983  GSL=f  GSL=f
984    
985  CLEANUP=f  CLEANUP=f
# Line 926  MKDEPEND= Line 1004  MKDEPEND=
1004  if test "x$MAKE" = x ; then  if test "x$MAKE" = x ; then
1005      MAKE=make      MAKE=make
1006  fi  fi
1007    REPLMAKE=
1008  if test "x$CC" = x ; then  if test "x$CC" = x ; then
1009      CC=cc      CC=cc
1010  fi  fi
1011  JOBS=  JOBS=
1012    TARG=
1013  MPI=0  MPI=0
1014  MPI_MFILE=  MPI_MFILE=
1015  MULTI_THREAD=f  MULTI_THREAD=f
1016  OUTDIR=  OUTDIR=
1017  DELDIR=  DELDIR=
1018  USE_R4=  USE_R4=
1019    EXTRFLG=
1020    
1021  ADM=  #- type of testing (KIND):
1022  OADM=  #   KIND=0 : forward (= default) ;  KIND=1 : Tangent Linear with TAF ;
1023    #   KIND=2 : Adjoint with TAF ;     KIND=4 : Adjoint with OpenAD
1024    KIND=0
1025    
1026  # list of pTracers to check for monitor output  # list of pTracers to check for monitor output
1027  PTRACERS_NUM="1 2 3 4 5"  PTRACERS_NUM="1 2 3 4 5"
# Line 988  for ac_option ; do Line 1071  for ac_option ; do
1071          -make | --make | -m | --m) ac_prev=MAKE ;;          -make | --make | -m | --m) ac_prev=MAKE ;;
1072          -make=* | --make=* | -m=* | --m=*) MAKE=$ac_optarg ;;          -make=* | --make=* | -m=* | --m=*) MAKE=$ac_optarg ;;
1073    
1074            -repl_mk | --repl_mk ) ac_prev=REPLMAKE ;;
1075            -repl_mk=* | --repl_mk=*) REPLMAKE=$ac_optarg ;;
1076    
1077          -odir | --odir) ac_prev=OUTDIR ;;          -odir | --odir) ac_prev=OUTDIR ;;
1078          -odir=* | --odir=*) OUTDIR=$ac_optarg ;;          -odir=* | --odir=*) OUTDIR=$ac_optarg ;;
1079    
# Line 1000  for ac_option ; do Line 1086  for ac_option ; do
1086          -j | --j) ac_prev=JOBS ;;          -j | --j) ac_prev=JOBS ;;
1087          -j=* | --j=*) JOBS=$ac_optarg ;;          -j=* | --j=*) JOBS=$ac_optarg ;;
1088    
1089            -ef | --ef) ac_prev=EXTRFLG ;;
1090            -ef=* | --ef=*) EXTRFLG=$ac_optarg ;;
1091    
1092          -clean | --clean) CLEANUP=t ; DELDIR=t ;;          -clean | --clean) CLEANUP=t ; DELDIR=t ;;
1093    
1094          -norun | --norun | -nr | --nr) NORUN=t ;;          -norun | --norun | -nr | --nr) NORUN=t ;;
1095            -obj | --obj ) TARG='obj' ; NORUN=t ;;
1096          -runonly | --runonly | -ro | --ro) QUICK=t ; NOMAKE=t ;;          -runonly | --runonly | -ro | --ro) QUICK=t ; NOMAKE=t ;;
1097          -quick | --quick | -q | --q) QUICK=t ;;          -quick | --quick | -q | --q) QUICK=t ;;
1098          -nogenmake | --nogenmake | -ng | --ng) NOGENMAKE=t ;;          -nogenmake | --nogenmake | -ng | --ng) NOGENMAKE=t ;;
# Line 1021  for ac_option ; do Line 1111  for ac_option ; do
1111    
1112          -mth) MULTI_THREAD=t ;;          -mth) MULTI_THREAD=t ;;
1113    
1114          -adm | -ad) ADM=t ;;          -tlm) if test $KIND = 0 ; then KIND=1 ; else
1115          -oad) OADM=t; NODEPEND=t ;;                  echo "Error: '-tlm', '-adm' and '-oad' are exclusive" ; usage
1116                  fi ;;
1117          -ieee) IEEE=true ;;          -adm | -ad) if test $KIND = 0 ; then KIND=2 ; else
1118          -noieee) IEEE= ;;                  echo "Error: '-tlm', '-adm' and '-oad' are exclusive" ; usage
1119                  fi ;;
1120            -oad) if test $KIND = 0 ; then KIND=4 ; NODEPEND=t ; else
1121                    echo "Error: '-tlm', '-adm' and '-oad' are exclusive" ; usage
1122                  fi ;;
1123    
1124            -ieee)   echo "Warning: ignore option '-ieee' (already the default)"
1125                     printf " ... " ;;
1126            -noieee) echo "Warning: will use option '-fast' instead of '-noieee' (obsolete)"
1127                     printf " ... " ; OptLev=`expr $OptLev \* 2` ;;
1128            -fast)  OptLev=`expr $OptLev \* 2` ;;
1129            -devel) OptLev=0 ;;
1130          -gsl) GSL=t ;;          -gsl) GSL=t ;;
1131    
1132          -verbose) verbose=2 ;;          -verbose) verbose=2 ;;
# Line 1060  if test "x$MPI" != x0 -a "x$MPI_MFILE" ! Line 1161  if test "x$MPI" != x0 -a "x$MPI_MFILE" !
1161      if test -r $MPI_MFILE ; then      if test -r $MPI_MFILE ; then
1162          nl=`wc -l $MPI_MFILE | awk '{print $1}'`          nl=`wc -l $MPI_MFILE | awk '{print $1}'`
1163          if [ $nl -lt $MPI ] ; then          if [ $nl -lt $MPI ] ; then
1164            echo "Error: need at least $MPI nodes (currently only $nl) in MPI_MFILE=$MPI_FILE"            echo "Error: need at least $MPI nodes (currently only $nl) in MPI_MFILE=$MPI_FILE"
1165            usage            usage
1166          fi          fi
1167          if [ $verbose -gt 1 ]; then          if [ $verbose -gt 1 ]; then
1168              echo " MPI_MFILE=$MPI_MFILE : $nl procs for MPI=$MPI run"              echo " MPI_MFILE=$MPI_MFILE : $nl procs for MPI=$MPI run"
1169          fi          fi
1170      else      else
1171            echo "Error: cannot access MPI_MFILE=$MPI_FILE"            echo "Error: cannot access MPI_MFILE=$MPI_FILE"
1172            usage            usage
1173      fi      fi
1174  fi  fi
1175    
1176  #- setting for forward or ADM testing  #- setting for forward or ADM testing
1177  if test "x$ADM" = xt ; then  if test $KIND = 1 ; then
1178        TARG=ftlall
1179        code_dir=code_ad
1180        inputdir=input_ad
1181        ref_outp="output_tlm.txt"
1182        EXECUTABLE="mitgcmuv_ftl"
1183    elif test $KIND = 2 ; then
1184        if test "x$TARG" = xobj ; then TARG=adobj ; else TARG=adall ; fi
1185      code_dir=code_ad      code_dir=code_ad
1186      inputdir=input_ad      inputdir=input_ad
1187      ref_outp="output_adm.txt"      ref_outp="output_adm.txt"
1188      EXECUTABLE="mitgcmuv_ad"      EXECUTABLE="mitgcmuv_ad"
1189  elif test "x$OADM" = xt ; then  elif test $KIND = 4 ; then
1190        TARG=adAll
1191      code_dir=code_oad      code_dir=code_oad
1192      inputdir=input_oad      inputdir=input_oad
1193      ref_outp="output_oadm.txt"      ref_outp="output_oadm.txt"
1194      EXECUTABLE="mitgcmuv_ad"      EXECUTABLE="mitgcmuv_ad"
1195  else  else
1196        if test "x$JOBS" != x ; then TARG="-j $JOBS $TARG" ; fi
1197      code_dir=code      code_dir=code
1198      inputdir=input      inputdir=input
1199      ref_outp="output.txt"      ref_outp="output.txt"
# Line 1127  do Line 1237  do
1237              echo ""; echo -n " -- skip \"$xx\" (not a directory !)"              echo ""; echo -n " -- skip \"$xx\" (not a directory !)"
1238          fi          fi
1239      else      else
1240          if test $count = 1 ; then echo -n ", \"$xx\""          if test $count = 1 ; then echo -n ", \"$xx\""
1241          else count=1 ; echo "" ;  echo -n " skip: \"$xx\""          else count=1 ; echo "" ;  echo -n " skip: \"$xx\""
1242          fi          fi
1243      fi      fi
# Line 1155  echo "OK (COMMAND= $COMMAND )" Line 1265  echo "OK (COMMAND= $COMMAND )"
1265  #  (use default or load experiment-specific list from file "tr_checklist")  #  (use default or load experiment-specific list from file "tr_checklist")
1266  # content : 1rst = main variable used to decide if it pass or FAIL  # content : 1rst = main variable used to decide if it pass or FAIL
1267  #         others = number of matching digits to be printed in summary.txt  #         others = number of matching digits to be printed in summary.txt
1268  if test "x$ADM" = x -a "x$OADM" = x; then  if test $KIND = 1 ; then
1269        DEF_CHECK_LIST='tlmGrd tlmCst tlmGrd fwdGrd'
1270        EMPTY_RESULTS='.. .. ..'
1271        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1272    elif test $KIND = 2 -o $KIND = 4 ; then
1273        DEF_CHECK_LIST='AdGrd Cost AdGrd FDGrd'
1274        EMPTY_RESULTS='.. .. ..'
1275        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1276    else
1277      DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'      DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'
1278      EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'      EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'
1279      LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`      LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1280      ii=`echo $EMPTY_RESULTS | awk '{print NF}'`      ii=`echo $EMPTY_RESULTS | awk '{print NF}'`
1281      EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`      EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`
 else  
     DEF_CHECK_LIST='Grad Cost Grad'  
     EMPTY_RESULTS='.. ..'  
     LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`  
1282  fi  fi
1283    
1284  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
1285  if test -x tr_cmpnum ; then  if test "x$CLEANUP" = xt -o -x tr_cmpnum ; then
1286      echo "skipping comparison code build"      echo "skipping comparison code build"
1287  else  else
1288      createcodelet      createcodelet
# Line 1184  fi Line 1298  fi
1298  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
1299  CMDLINE=$0  CMDLINE=$0
1300  for xx in "$@" ; do nw=`echo $xx | wc -w`  for xx in "$@" ; do nw=`echo $xx | wc -w`
1301      if test $nw = '1' ; then CMDLINE="$CMDLINE $xx"      if test $nw = '1' ; then CMDLINE="$CMDLINE $xx" ; else
1302                          else CMDLINE="$CMDLINE '$xx'" ; fi        nb=`echo $xx | grep -c '='`
1303          if test $nb = 0 ; then CMDLINE="$CMDLINE '$xx'"
1304          else yy=`echo "$xx'" | sed "s/=/='/"` ;
1305                                 CMDLINE="$CMDLINE $yy" ; fi
1306        fi
1307  done  done
1308  #for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done  #for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done
1309  MACH=`hostname`  MACH=`hostname`
# Line 1232  if test "x$OPTFILE" != xNONE ; then Line 1350  if test "x$OPTFILE" != xNONE ; then
1350          echo >> $SUMMARY          echo >> $SUMMARY
1351          echo "  OPTFILE=$OPTFILE" >> $SUMMARY          echo "  OPTFILE=$OPTFILE" >> $SUMMARY
1352      else      else
1353          echo | tee $SUMMARY          echo | tee -a $SUMMARY
1354          echo "ERROR: can't read OPTFILE=\"$OPTFILE\"" | tee $SUMMARY          echo "ERROR: can't read OPTFILE=\"$OPTFILE\"" | tee -a $SUMMARY
1355          exit 1          exit 1
1356      fi      fi
1357  else  else
# Line 1243  else Line 1361  else
1361  fi  fi
1362  echo  echo
1363  echo >> $SUMMARY  echo >> $SUMMARY
1364  if test "x$ADM" = x -a "x$OADM" = x; then  if test $KIND = 0 ; then
1365      if [ $MATCH_CRIT -lt 10 ] ;      line_0=`printf '%s %2i' 'default' $MATCH_CRIT`
     then line_0="default  "$MATCH_CRIT ;  
     else line_0="default "$MATCH_CRIT ; fi  
1366         line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"         line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"
1367      line_1="G D M    c        m  s        m  s        m  s        m  s"      line_1="G D M    c        m  s        m  s        m  s        m  s"
1368      line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."      line_2="e p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."
1369      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"      line_3="n n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"
1370      line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."      line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."
1371      for ii in $PTRACERS_NUM ; do      for ii in $PTRACERS_NUM ; do
1372          line_0="$line_0  --PTR 0"$ii"--"          line_0="$line_0  --PTR 0"$ii"--"
# Line 1259  if test "x$ADM" = x -a "x$OADM" = x; the Line 1375  if test "x$ADM" = x -a "x$OADM" = x; the
1375          line_3="$line_3  i  a  a  d"          line_3="$line_3  i  a  a  d"
1376          line_4="$line_4  n  x  n  ."          line_4="$line_4  n  x  n  ."
1377      done      done
1378    else
1379        line_0=`printf '%s %2i' 'default   ' $MATCH_CRIT`
1380      if test $KIND = 1 ; then
1381       #echo "TANGLIN=true" >> $SUMMARY
1382        echo "TangLin generated by TAF" >> $SUMMARY
1383      elif test $KIND = 3 ; then
1384        echo "TangLin generated by OpenAD" >> $SUMMARY
1385      elif test $KIND = 2 ; then
1386       #echo "ADJOINT=true" >> $SUMMARY
1387        echo "Adjoint generated by TAF" >> $SUMMARY
1388      else
1389        echo "Adjoint generated by OpenAD" >> $SUMMARY
1390      fi
1391      if test $KIND = 1 -o $KIND = 3 ; then
1392        line_1="G D M    C  T  F"
1393        line_2="e p a R  o  L  D"
1394      else
1395        line_1="G D M    C  A  F"
1396        line_2="e p a R  o  d  D"
1397      fi
1398        line_3="n n k u  s  G  G"
1399        line_4="2 d e n  t  r  r"
1400        echo >> $SUMMARY
1401    fi
1402    if test "x$CLEANUP" != xt ; then
1403      echo "$line_0" | tee -a $SUMMARY      echo "$line_0" | tee -a $SUMMARY
1404      echo "$line_1" | tee -a $SUMMARY      echo "$line_1" | tee -a $SUMMARY
1405      echo "$line_2" | tee -a $SUMMARY      echo "$line_2" | tee -a $SUMMARY
1406      echo "$line_3" | tee -a $SUMMARY      echo "$line_3" | tee -a $SUMMARY
1407      echo "$line_4" | tee -a $SUMMARY      echo "$line_4" | tee -a $SUMMARY
1408      echo " "       | tee -a $SUMMARY      echo ""        | tee -a $SUMMARY
 else  
     echo "ADJOINT=true" >> $SUMMARY  
     echo >> $SUMMARY  
     if [ $MATCH_CRIT -lt 10 ] ;  
     then line_0="default     "$MATCH_CRIT ;  
     else line_0="default    "$MATCH_CRIT ; fi  
     echo "$line_0" | tee -a $SUMMARY  
     cat << EOF | tee -a $SUMMARY  
 G D M    C  G  
 E p a R  o  r  
 N n k u  s  a  
 2 d e n  t  d  
   
 EOF  
1409  fi  fi
1410  echo "-------------------------------------------------------------------------------"  echo "-------------------------------------------------------------------------------"
1411    
# Line 1306  for dir in $TESTDIRS ; do Line 1433  for dir in $TESTDIRS ; do
1433              rm -f SIZE.h.mpi genmake.tr_log make.tr_log              rm -f SIZE.h.mpi genmake.tr_log make.tr_log
1434          )          )
1435          if test -d $dir/$rundir/CVS ; then          if test -d $dir/$rundir/CVS ; then
1436              echo -n '  --- dir:' $dir/$rundir ': '              echo -n '  --- dir:' $dir/$rundir ': '
1437              run_clean $dir/$rundir              run_clean $dir/$rundir
1438          fi          fi
1439          trdir=`( cd $dir ; find . -type d -name "$pfxdir.*" -print | sed 's/^.\///')`          trdir=`( cd $dir ; find . -type d -name "$pfxdir.*" -print | sed 's/^.\///')`
# Line 1321  for dir in $TESTDIRS ; do Line 1448  for dir in $TESTDIRS ; do
1448      #  Verify that the testdir exists and contains previous      #  Verify that the testdir exists and contains previous
1449      #  results in the correct location--or skip this directory!      #  results in the correct location--or skip this directory!
1450      fout=$dir"/results/"$ref_outp      fout=$dir"/results/"$ref_outp
1451      if test ! -r $fout ; then     #if test ! -r $fout ; then
1452        if test ! -r $fout -a ! -r ${fout}.gz ; then
1453          echo "can't read \"$fout\" -- skipping $dir"          echo "can't read \"$fout\" -- skipping $dir"
1454          continue          continue
1455      fi      fi
1456    
1457      # Check for specific files for particular type of run      # Check for specific files for particular type of run
1458    
1459        if test ! -r $CODE_DIR"/SIZE.h_mpi"  -a "x$MPI" != "x0" ; then
1460            echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
1461            continue
1462        fi
1463        if test ! -r $dir"/input/eedata.mth" -a "x$MULTI_THREAD" = "xt" ; then
1464            echo "can't find \"$dir/input/eedata.mth\" -- skipping $dir"
1465            continue
1466        fi
1467    
1468      if test "x$MPI" != "x0" ; then      if test "x$MPI" != "x0" ; then
1469          if test -r $CODE_DIR"/SIZE.h_mpi" ; then          ntx=1 ; nty=1
1470              #- create new SIZE.h with no more than '$MPI' Procs          if test "x$MULTI_THREAD" = "xt" ; then
1471              mk_mpi_size $CODE_DIR"/SIZE.h_mpi" $BUILD_DIR"/tr_size.mpi" $MPI            ff=$dir"/input/eedata.mth"
1472              LOC_NPROC=$?            ntx=`grep "^ *nTx *=" $ff | tail -1 | sed 's/^ *nTx *= *//' | sed "s/, *$//"`
1473              (   cd $BUILD_DIR            nty=`grep "^ *nTy *=" $ff | tail -1 | sed 's/^ *nTy *= *//' | sed "s/, *$//"`
1474                  if test -r SIZE.h.mpi ; then            if test "x$ntx" = x ; then ntx=1 ; fi
1475                      cmp tr_size.mpi SIZE.h.mpi > /dev/null 2>&1 ; RETVAL=$?            if test "x$nty" = x ; then nty=1 ; fi
1476                  else RETVAL=1          fi
1477                  fi          #- create new SIZE.h with no more than '$MPI' Procs
1478                  if test "x$RETVAL" = x0 ; then          mk_mpi_size $CODE_DIR"/SIZE.h_mpi" $BUILD_DIR"/tr_size.mpi" $MPI $ntx $nty
1479                      rm -f tr_size.mpi          LOC_NPROC=$?
1480                  else          (   cd $BUILD_DIR
1481                      rm -f SIZE.h.mpi ; mv tr_size.mpi SIZE.h.mpi              if test -r SIZE.h.mpi ; then
1482                  fi                  cmp tr_size.mpi SIZE.h.mpi > /dev/null 2>&1 ; RETVAL=$?
1483              )              else RETVAL=1
1484          else              fi
1485              echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"              if test "x$RETVAL" = x0 ; then
1486              continue                  rm -f tr_size.mpi
1487          fi              else
1488                    rm -f SIZE.h.mpi ; mv tr_size.mpi SIZE.h.mpi
1489                fi
1490            )
1491          if test "x$MPI_MFILE" != x ; then          if test "x$MPI_MFILE" != x ; then
1492              #- create new MPI machine-file with the right number of Procs              #- create new MPI machine-file with the right number of Procs
1493              rm -f $LOC_MFILE              rm -f $LOC_MFILE
# Line 1363  for dir in $TESTDIRS ; do Line 1503  for dir in $TESTDIRS ; do
1503                  echo " new LOC_MFILE=$LOC_MFILE : $nl procs for LOC_NPROC=$LOC_NPROC"                  echo " new LOC_MFILE=$LOC_MFILE : $nl procs for LOC_NPROC=$LOC_NPROC"
1504              fi              fi
1505          fi          fi
1506      fi          if test "x$MULTI_THREAD" = "xt" ; then
1507      if test ! -r $dir"/input/eedata.mth" -a "x$MULTI_THREAD" = "xt" ; then              retv=`check_eedata $dir"/input/eedata.mth" $BUILD_DIR"/SIZE.h.mpi"`
1508          echo "can't find \"$dir/input/eedata.mth\" -- skipping $dir"              if test $retv != 0 ; then
1509          continue                  echo "input/eedata.mth tiling misfit -- skipping $dir"
1510      fi                  continue
1511      if test "x$MPI" != "x0" -a "x$MULTI_THREAD" = "xt" ; then              fi
         retv=`check_eedata $BUILD_DIR"/SIZE.h.mpi" $dir"/input/eedata.mth"`  
         if test $retv != 0 ; then  
             echo "input/eedata.mth tiling misfit -- skipping $dir"  
             continue  
1512          fi          fi
1513      fi      fi
1514    
# Line 1386  for dir in $TESTDIRS ; do Line 1522  for dir in $TESTDIRS ; do
1522          name=`echo $exd | sed -e "s/$inputdir\.//"`          name=`echo $exd | sed -e "s/$inputdir\.//"`
1523          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1524          outf="$dir/results/$refExOut"          outf="$dir/results/$refExOut"
1525          if test -f $outf -a -r $outf ; then          #if test -f $outf -a -r $outf ; then
1526            if test -r $outf -o -r ${outf}.gz ; then
1527            if test "x$MULTI_THREAD" = "xt" ; then            if test "x$MULTI_THREAD" = "xt" ; then
1528              if test -r $dir"/"$exd"/eedata.mth" ; then              if test -r $dir"/"$exd"/eedata.mth" ; then
1529                if test "x$MPI" = "x0" ; then                if test "x$MPI" = "x0" ; then
1530                  extra_runs="$extra_runs $name"                  extra_runs="$extra_runs $name"
1531                else                else
1532                  retv=`check_eedata $BUILD_DIR"/SIZE.h.mpi" $dir"/"$exd"/eedata.mth"`                  retv=`check_eedata $dir"/"$exd"/eedata.mth" $BUILD_DIR"/SIZE.h.mpi"`
1533                  if test $retv = 0 ; then                  if test $retv = 0 ; then
1534                      extra_runs="$extra_runs $name"                      extra_runs="$extra_runs $name"
1535                  else                  else
# Line 1409  for dir in $TESTDIRS ; do Line 1546  for dir in $TESTDIRS ; do
1546    
1547      echo      echo
1548      if test "x$extra_runs" = "x" ; then      if test "x$extra_runs" = "x" ; then
1549         echo "Experiment:  $dir"          echo "Experiment:  $dir"
1550      else      else
1551         echo "Experiment:  $dir ; extra_runs=$extra_runs"          echo "Experiment:  $dir ; extra_runs=$extra_runs"
1552      fi      fi
1553      echo      echo
1554      unset genmake makedepend make run      unset genmake makedepend make run
# Line 1430  for dir in $TESTDIRS ; do Line 1567  for dir in $TESTDIRS ; do
1567              run=N              run=N
1568          genmakemodel $dir/$builddir && genmake=Y \          genmakemodel $dir/$builddir && genmake=Y \
1569              && makeclean $dir/$builddir \              && makeclean $dir/$builddir \
1570              && symlink_mpifiles $dir $code_dir $builddir \              && symlink_mpifiles $dir $code_dir $builddir \
1571              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1572              && makemodel $dir/$builddir && make=Y              && makemodel $dir/$builddir && make=Y
1573      else      else
1574          genmakemodel $dir/$builddir && genmake=Y \          genmakemodel $dir/$builddir && genmake=Y \
1575              && makeclean $dir/$builddir \              && makeclean $dir/$builddir \
1576              && symlink_mpifiles $dir $code_dir $builddir \              && symlink_mpifiles $dir $code_dir $builddir \
1577              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1578              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
1579              && run_clean $dir/$rundir \              && run_clean $dir/$rundir \
# Line 1448  for dir in $TESTDIRS ; do Line 1585  for dir in $TESTDIRS ; do
1585    
1586          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1587          echo 1>&2          echo 1>&2
1588          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1589          echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $locDIR"/summary.txt"          echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $locDIR"/summary.txt"
1590    
1591          for ex in $extra_runs ; do          for ex in $extra_runs ; do
1592              unset run              unset run
1593              results=$EMPTY_RESULTS              results=$EMPTY_RESULTS
1594              #  reference output file              #  reference output file
1595              refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`              refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`
1596              #  Create an output dir & summary.txt file for each extra run (tdir.ex)              #  Create an output dir & summary.txt file for each extra run (tdir.ex)
# Line 1479  for dir in $TESTDIRS ; do Line 1616  for dir in $TESTDIRS ; do
1616              fi              fi
1617          done          done
1618    
1619      if test -f $DRESULTS"/"genmake_state ; then : ; else      if test ! -f $DRESULTS"/"genmake_state ; then
1620          if test -f $dir/$builddir/Makefile ; then          if test -f $dir/$builddir/Makefile ; then
1621              mkOpt=`grep '^# OPTFILE=' $dir/$builddir/Makefile 2>/dev/null | head -1 | sed 's/^# //'`              mkOpt=`grep '^# OPTFILE=' $dir/$builddir/Makefile 2>/dev/null | head -1 | sed 's/^# //'`
1622              echo "from '$dir/$builddir/Makefile', extract:" > $DRESULTS/genmake_state              echo "from '$dir/$builddir/Makefile', extract:" > $DRESULTS/genmake_state
# Line 1488  for dir in $TESTDIRS ; do Line 1625  for dir in $TESTDIRS ; do
1625              if test "x$OPTFILE" = xNONE ; then              if test "x$OPTFILE" = xNONE ; then
1626                  eval $mkOpt                  eval $mkOpt
1627                  sed "/^No \"OPTFILE\" was specified ; genmake2/a\  OPTFILE=${OPTFILE}"\                  sed "/^No \"OPTFILE\" was specified ; genmake2/a\  OPTFILE=${OPTFILE}"\
1628                          $SUMMARY > tr_0.tmp_log                          $SUMMARY > tmp.tr_log
1629                  RETVAL=$?                  RETVAL=$?
1630                  if test "x$RETVAL" = x0 ; then rm -f $SUMMARY                  if test "x$RETVAL" = x0 ; then rm -f $SUMMARY
1631                          cp tr_0.tmp_log $SUMMARY                          cp tmp.tr_log $SUMMARY
1632                  else rm -f tr_0.tmp_log                  else rm -f tmp.tr_log
1633                  fi                  fi
1634              fi              fi
1635              gmkLog=$dir/$builddir/genmake.log              gmkLog=$dir/$builddir/genmake.log
1636              grep '^Get compiler version using:' $gmkLog > /dev/null 2>&1              if test -r $gmkLog ; then
1637              RETVAL=$?                  grep '^Get compiler version using:' $gmkLog > /dev/null 2>&1
1638              if test "x$RETVAL" = x0 ; then                  RETVAL=$?
1639                  echo "from '$gmkLog', extract compiler version:" >> $DRESULTS/genmake_state                  if test "x$RETVAL" = x0 ; then
1640                  sed -n '/Get compiler version/,/<-- compiler version/p' $gmkLog \                    echo -n "from '$gmkLog', " >> $DRESULTS/genmake_state
1641                         | grep -v '^... compiler version ' > tr_1.tmp_log                    echo "extract compiler version:"   >> $DRESULTS/genmake_state
1642                  sed -n '1,/^$/p' tr_1.tmp_log | sed '/^$/d' | sed 's/^./ &/' \                    sed -n '/Get compiler version/,/<-- compiler version/p' \
1643                          >> $DRESULTS/genmake_state                       $gmkLog | grep -v '^... compiler version ' > tmp.tr_log
1644                  rm -f tr_1.tmp_log                    sed -n '1p' tmp.tr_log >> $DRESULTS/genmake_state
1645                      sed -n '2,/^$/p' tmp.tr_log | sed '/^$/d' | sed 's/^./ &/' \
1646                                             >> $DRESULTS/genmake_state
1647                      rm -f tmp.tr_log
1648                    fi
1649                    echo -n "from '$gmkLog', " >> $DRESULTS/genmake_state
1650                    echo "get NETCDF & LAPACK settings:" >> $DRESULTS/genmake_state
1651                    sed -n '/set HAVE_NETCDF=/p' $gmkLog >> $DRESULTS/genmake_state
1652                    sed -n '/set HAVE_LAPACK=/p' $gmkLog >> $DRESULTS/genmake_state
1653              fi              fi
1654          fi          fi
1655      fi      fi
1656      #postclean $dir/$builddir      #postclean $dir/$builddir
1657      if test "x$POSTCLEAN" = x2 ; then      if test "x$POSTCLEAN" = x2 ; then
1658          makeclean $dir/$builddir \          makeclean $dir/$builddir \
1659              && run_clean $dir/$rundir              && run_clean $dir/$rundir
1660      fi      fi
1661      if test "x$MPI" != x0 -a "x$MPI_MFILE" != x ; then rm -f $LOC_MFILE ; fi      if test "x$MPI" != x0 -a "x$MPI_MFILE" != x ; then rm -f $LOC_MFILE ; fi
1662    
# Line 1558  fi Line 1703  fi
1703  if test "x$CLEANUP" != xt ; then  if test "x$CLEANUP" != xt ; then
1704      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'
1705      if test -e tr_out.txt ; then      if test -e tr_out.txt ; then
1706          mv tr_out.txt tr_out.txt.old          mv tr_out.txt tr_out.txt.old
1707      fi      fi
1708      cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/ \. //g' > tr_out.txt      cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/ \. //g' > tr_out.txt
1709  fi  fi
# Line 1566  fi Line 1711  fi
1711  if test "x$DELDIR" = xt ; then  if test "x$DELDIR" = xt ; then
1712      rm -rf $DRESULTS      rm -rf $DRESULTS
1713  fi  fi
1714    echo "======== End of testreport execution ========"

Legend:
Removed from v.1.160  
changed lines
  Added in v.1.182

  ViewVC Help
Powered by ViewVC 1.1.22